package opc

import (
	"time"

	"gorm.io/gorm"

	"wucher/internal/shared/pkg/uuidv7"
)

type Opc struct {
	ID        []byte `gorm:"type:binary(16);primaryKey;column:id"`
	Title     string `gorm:"type:varchar(64);uniqueIndex;not null;column:name"`
	SortKey   *int   `gorm:"column:sortkey"`
	Note      string `gorm:"type:varchar(255);column:note"`
	IsActive  bool   `gorm:"type:tinyint(1);index;not null;default:1;column:is_active"`
	CreatedAt time.Time
	CreatedBy []byte `gorm:"type:binary(16);column:created_by"`
	UpdatedAt time.Time
	UpdatedBy []byte     `gorm:"type:binary(16);column:updated_by"`
	DeletedAt *time.Time `gorm:"column:deleted_at"`
	DeletedBy []byte     `gorm:"type:binary(16);column:deleted_by"`
}

func (Opc) TableName() string { return "hems_opcs" }

func (o *Opc) BeforeCreate(tx *gorm.DB) error {
	if len(o.ID) == 0 {
		o.ID = uuidv7.MustBytes()
	}
	return nil
}
